<?xml version="1.0" encoding="UTF-8"?>
<p:declare-step 
		xmlns:c="http://www.w3.org/ns/xproc-step"
		xmlns:cx="http://xmlcalabash.com/ns/extensions"
		xmlns:nvdl="http://purl.oclc.org/dsdl/nvdl/ns/structure/1.0"
		xmlns:p="http://www.w3.org/ns/xproc" 
		xmlns:pxp="http://exproc.org/proposed/steps"
		xmlns:xf="http://www.w3.org/2002/xforms"
		xmlns:xhtml="http://www.w3.org/1999/xhtml"
		xml:base="../../"
		name="nvdl-retrieve-xforms-test-suite"
		version="0.3">
	<p:documentation>NVDL Validates the XForms 1.1 Test Suite documents.</p:documentation>
	
	<p:input port="source" primary="true">
		<p:document href="http://www.w3.org/MarkUp/Forms/Test/XForms1.1/Edition1/driverPages/html/"/>
	</p:input>
	<p:output port="result"/>
	
	<p:serialization port="result" encoding="utf-8" indent="true" 
			media-type="application/xml" method="xml"/>
	
	<p:import href="xproc/library-1.0.xpl"/>
	<p:import href="test/xproc/retrieve-xforms-test-suite.xpl"/>
	
	
	<xf:retrieve-tests>
		<p:documentation>Retrieves the XForms Test Suite test documents.</p:documentation>
	</xf:retrieve-tests>
	
	<p:for-each>
		<p:iteration-source select="/*"/>
		
		<p:variable name="baseURI" select="/c:result/@href"/>
		
		<p:unwrap name="test" match="/c:result"/>
		
		<!-- Use the delete step to filter-out the @class, @accesskey and @navindex errors. -->
		<!--
			<p:delete match="//xf:*/attribute::*[local-name() = ('class', 'accesskey', 'navindex')]"></p:delete>
		-->
		
		<p:try>
			<p:group>
				<cx:nvdl name="validate" assert-valid="true">
					<p:input port="source"/>
					<p:input port="nvdl">
						<p:document href="nvdl/xhtml-xforms11.nvdl"/>
					</p:input>
					<p:input port="schemas">
						<p:empty/>
					</p:input>
				</cx:nvdl>
				<p:sink/>
				
				<p:identity>
					<p:input port="source">
						<p:inline exclude-inline-prefixes="#all"><c:success/></p:inline>
					</p:input>
				</p:identity>
			</p:group>
			<p:catch name="catch">
				<cx:message>
					<p:with-option name="message" select="concat('[Error] ', /xhtml:html/xhtml:head/xhtml:title)">
						<p:pipe port="result" step="test"/>
					</p:with-option>
				</cx:message>
				
				<p:identity>
					<p:input port="source">
						<p:pipe port="error" step="catch"/>
					</p:input>
				</p:identity>
			</p:catch>
		</p:try>
				
		<p:add-attribute attribute-name="title" match="/*">
			<p:with-option name="attribute-value" select="/xhtml:html/xhtml:head/xhtml:title">
				<p:pipe port="result" step="test"/>
			</p:with-option>
		</p:add-attribute>
		
		<p:add-attribute attribute-name="href" match="/*">
			<p:with-option name="attribute-value" select="$baseURI"/>
		</p:add-attribute>
	</p:for-each>
	
	<p:wrap-sequence wrapper="c:results"/>
</p:declare-step>