<?xml version="1.0" encoding="UTF-8"?>
<p:library xmlns:c="http://www.w3.org/ns/xproc-step"
		xmlns:cx="http://xmlcalabash.com/ns/extensions"
		xmlns:nvdl="http://purl.oclc.org/dsdl/nvdl/ns/structure/1.0"
		xmlns:p="http://www.w3.org/ns/xproc" 
		xmlns:pxp="http://exproc.org/proposed/steps"
		xmlns:xf="http://www.w3.org/2002/xforms"
		xmlns:xhtml="http://www.w3.org/1999/xhtml"
		version="0.2">
	
	<p:declare-step type="xf:retrieve-tests">
		<p:documentation>Retrieve the XForms 1.1 Test Suite documents.</p:documentation>
		
		<p:input port="source" primary="true"/>
		<p:output port="result" sequence="true"/>
		
		<p:for-each>
			<p:iteration-source select="/xhtml:html/xhtml:body/xhtml:h3[position() gt 1]/xhtml:a[@class = 'testChapterTitle']"/>
			
			<p:variable name="baseURI" select="p:base-uri()"/>
			
			<p:make-absolute-uris match="/xhtml:a/@href">
				<p:with-option name="base-uri" select="$baseURI"/>
			</p:make-absolute-uris>
			
			<p:add-attribute attribute-name="href" match="c:request">
				<p:input port="source">
					<p:inline exclude-inline-prefixes="#all">
						<c:request method="GET" override-content-type="application/xhtml+xml"/>
					</p:inline>
				</p:input>
				<p:with-option name="attribute-value" select="/xhtml:a/@href"/>
			</p:add-attribute>
			
			<p:http-request method="xml" media-type="application/xhtml+xml" encoding="UTF-8" indent="true" omit-xml-declaration="true"/>
			
			<p:make-absolute-uris match="/xhtml:html/xhtml:body/xhtml:table/xhtml:tr[xhtml:td]/xhtml:td/xhtml:a/@href">
				<p:with-option name="base-uri" select="$baseURI"/>
			</p:make-absolute-uris>
			
			<p:for-each>
				<p:iteration-source select="/xhtml:html/xhtml:body/xhtml:table/xhtml:tr[xhtml:td]"/>
				
				<p:variable name="testName" select="subsequence(reverse(tokenize(/xhtml:tr/xhtml:td[1]/xhtml:a/@href, '/')), 1, 1)"/>
				
				<p:identity name="link"/>
				
				<p:try name="try">
					<p:documentation>An ugly bit of mucking-around to deal with a problem
						that Calabash has in retrieving the SVG example in Appendix H.</p:documentation>
					<p:group>
						<p:add-attribute attribute-name="href" match="c:request">
							<p:input port="source">
								<p:inline exclude-inline-prefixes="#all">
									<c:request method="GET" override-content-type="application/xml"/>
								</p:inline>
							</p:input>
							<p:with-option name="attribute-value" select="/xhtml:tr/xhtml:td[1]/xhtml:a/@href"/>
						</p:add-attribute>
						<p:http-request method="xml" media-type="application/xml" encoding="UTF-8" indent="true" omit-xml-declaration="true"/>
					</p:group>
					<p:catch name="catch">
						<cx:message>
							<p:with-option name="message" select="concat('[Error] ', $testName)"/>
						</cx:message>
						
						<p:add-attribute attribute-name="href" match="c:request">
							<p:input port="source">
								<p:inline exclude-inline-prefixes="#all">
									<c:request method="GET"/>
								</p:inline>
							</p:input>
							<p:with-option name="attribute-value" select="/xhtml:tr/xhtml:td[1]/xhtml:a/@href">
								<p:pipe port="result" step="link"/>
							</p:with-option>
						</p:add-attribute>
						<p:http-request method="xml" media-type="application/xml" encoding="UTF-8" indent="true" omit-xml-declaration="true"/>
						<p:unescape-markup charset="UTF-8" content-type="application/xml" encoding="base64"/>
						<p:unwrap match="/c:body"/>
					</p:catch>
				</p:try>
				
				<p:wrap-sequence wrapper="c:result"/>
				<p:add-attribute match="/c:result" attribute-name="href">
					<p:with-option name="attribute-value" select="/xhtml:tr/xhtml:td[1]/xhtml:a/@href">
						<p:pipe port="result" step="link"/>
					</p:with-option>
				</p:add-attribute>
				
			</p:for-each>
		</p:for-each>
	</p:declare-step>
</p:library>