<?xml version="1.0" encoding="UTF-8"?>
<p:declare-step 
		xmlns:c="http://www.w3.org/ns/xproc-step"
		xmlns:cx="http://xmlcalabash.com/ns/extensions"
		xmlns:nvdl="http://purl.oclc.org/dsdl/nvdl/ns/structure/1.0"
		xmlns:p="http://www.w3.org/ns/xproc" 
		xmlns:pxp="http://exproc.org/proposed/steps"
		xmlns:xf="http://www.w3.org/2002/xforms"
		xmlns:xhtml="http://www.w3.org/1999/xhtml"
		xml:base="../../"
		name="save-xforms-test-suite"
		version="0.2">
	<p:documentation>Retrieves and saves the XForms 1.1 Test Suite documents.</p:documentation>
	
	<p:input port="source" primary="true">
		<p:document href="http://www.w3.org/MarkUp/Forms/Test/XForms1.1/Edition1/driverPages/html/"/>
	</p:input>
	
	<p:import href="xproc/library-1.0.xpl"/>
	<p:import href="test/xproc/retrieve-xforms-test-suite.xpl"/>
	
	<xf:retrieve-tests>
		<p:documentation>Retrieves the XForms Test Suite test documents.</p:documentation>
	</xf:retrieve-tests>
	
	<p:for-each>
		<p:iteration-source select="/*"/>
		
		<p:variable name="baseURI" select="/c:result/@href"/>
		
		<p:unwrap name="test" match="/c:result"/>
		
		<p:insert match="/*" position="last-child">
			<p:documentation>Add the oXygen NVDL Processing Instruction before the root element.</p:documentation>
			<p:input port="source">
				<p:inline exclude-inline-prefixes="#all"><wrapper><?oxygen NVDLSchema="../../nvdl/xhtml-xforms11.nvdl"?>&#10;</wrapper></p:inline>
			</p:input>
			<p:input port="insertion">
				<p:pipe port="result" step="test"/>
			</p:input>
		</p:insert>
		<p:unwrap match="/*"/>
		
		<p:store encoding="utf-8" media-type="application/xml" method="xml" indent="true" omit-xml-declaration="false">
			<p:with-option name="href" select="concat('test/resources/', subsequence(reverse(tokenize($baseURI, '/')), 1, 1))"/>
		</p:store>
	</p:for-each>
</p:declare-step>